明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1305|回复: 6

vba中想显示某个块用什么语句呢?

[复制链接]
发表于 2008-1-27 22:36:00 | 显示全部楼层 |阅读模式

请教:

是这样的,我有一个图形,有好多好多块,但里面3个块的名字都叫"AAA",这三个块中有XXX属性,三个块的XXX属性的值分别为1,2,3,我想用vba写个程序,找到块名为"AAA"的且XXX属性值为2的块,然后在AutoCAD图中定位到这个块的位置,也就是把这个块以合适的大小显示在图中间.这其中的显示的块的语句怎么写呢? 前面查找的块的属性值的语句要是能给就更好了

 楼主| 发表于 2008-1-27 23:25:00 | 显示全部楼层

补充一下,这三个块中都含有一个矩形的对象,我的目的也就是把那矩形的对角显示出来.

发表于 2008-1-28 12:04:00 | 显示全部楼层

用0,"insert"过滤,再获取块的属性值查找对应的属性,然后 zoom

 楼主| 发表于 2008-1-28 12:20:00 | 显示全部楼层

zoom某块的语句是什么呢,如果来个zoomall,我那个图中有上千块,根本找不到我要找的那个块

请教一下,0 insert过滤具体怎么实现呢?

 楼主| 发表于 2008-1-28 12:25:00 | 显示全部楼层

不好意思,我可能没有表达清楚,我的意思是我的图中已经有很多很多块参照了,有上千个,上万个,其中有3个块参照名字是“AAA”,他们有属性是XXX,值分别1,2,3,我现在要把那个值为1那个找到,并显示中屏幕中间。

发表于 2008-1-30 12:29:00 | 显示全部楼层

Sub tt()
    On Error Resume Next
    Dim ss As AcadSelectionSet
    ThisDrawing.SelectionSets("TlsTest").Delete
    Set ss = ThisDrawing.SelectionSets.Add("TlsTest")
   
    Dim ft(1) As Integer, fd(1)
    ft(0) = 0: fd(0) = "insert"
    ft(1) = 2: fd(1) = "AAA"
   
    ss.Select acSelectionSetAll, , , ft, fd
   
    Dim cblkref As AcadBlockReference
    Dim blkref As AcadBlockReference
    Dim arr
    Dim b As Boolean
    b = False
    Dim attref As AcadAttributeReference
    For Each blkref In ss
        arr = blkref.GetAttributes
        For Each attref In arr
            If attref.TagString = "XXX" Then
                If attref.TextString = "1" Then
                    Set cblkref = blkref
                    b = True
                    Exit For
                End If
                If b Then Exit For
            End If
        Next attref
    Next blkref
   
    Dim p1, p2
    cblkref.GetBoundingBox p1, p2
    Application.ZoomWindow p1, p2

End Sub

发表于 2008-1-30 12:32:00 | 显示全部楼层
  1. Sub tt()
  2.     On Error Resume Next
  3.     Dim ss As AcadSelectionSet
  4.     ThisDrawing.SelectionSets("TlsTest").Delete
  5.     Set ss = ThisDrawing.SelectionSets.Add("TlsTest")
  6.    
  7.     Dim ft(1) As Integer, fd(1)
  8.     ft(0) = 0: fd(0) = "insert"
  9.     ft(1) = 2: fd(1) = "AAA"
  10.    
  11.     ss.Select acSelectionSetAll, , , ft, fd
  12.    
  13.     Dim cblkref As AcadBlockReference
  14.     Dim arr
  15.     Dim b As Boolean
  16.     b = False
  17.     For Each blkref In ss
  18.         arr = blkref.GetAttributes
  19.         For Each attref In arr
  20.             If attref.TagString = "XXX" Then
  21.                 If attref.TextString = "1" Then
  22.                     Set cblkref = blkref
  23.                     b = True
  24.                     Exit For
  25.                 End If
  26.             End If
  27.         Next attref
  28.         If b Then Exit For
  29.     Next blkref
  30.    
  31.     Dim p1, p2
  32.     cblkref.GetBoundingBox p1, p2
  33.     Application.ZoomWindow p1, p2
  34. End Sub
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 10:19 , Processed in 0.185218 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表